autopkgtest (5.55~24.04.1) noble; urgency=medium

  * No-change backport from Noble (LP: #2144629)

 -- Antoine Lassagne <antoine.lassagne@canonical.com>  Tue, 17 Mar 2026 08:57:12 +0200

autopkgtest (5.55) unstable; urgency=medium

  [ Paride Legovini ]
  * a-virt-lxd: use the kernel boot_id to detect when a reboot happened
  * a-buildvm-ubuntu-cloud: fix URL generation
  * tests: run test_git_source_build using a trivial ad-hoc package

  [ Christian Kastner ]
  * build-docker: Fix supported architecture check
  * build-docker: Adapt to use docker multi-platform images (Closes: #1125712)
  * build-docker: Drop mips64el as a supported architecture
  * autopkgtest-build-podman: Fix APT proxy autodiscovery

  [ Simon McVittie ]
  * tests: Don't list more than one Maintainer (Closes: #1126318)
  * d/README.source: Update minimum host dependency versions

 -- Paride Legovini <paride@debian.org>  Sat, 31 Jan 2026 21:47:40 +0100

autopkgtest (5.54) unstable; urgency=medium

  [ Paride Legovini ]
  * Drop support for three dashes (---) as the virt-server separator
  * a-virt-lxd: refer to VMs/containers as "instances"

  [ Colin Watson ]
  * Call Incus instances autopkgtest-incus-*, not autopkgtest-lxd-*

  [ Florent 'Skia' Jacquet ]
  * adt_testbed: give some time to `apt` for acquiring the dpkg lock

  [ Christian Kastner ]
  * Set umask during mktemp call (Closes: #1107254)
  * qemu: Also remount user shared dirs after reboot

  [ Valentin Haudiquet ]
  * Set QEMU baseline profile for RISC-V to RVA23 (LP: #2137720)
  * Fix deprecated qemu-user-static usage

 -- Paride Legovini <paride@debian.org>  Fri, 23 Jan 2026 17:32:40 +0100

autopkgtest (5.53) unstable; urgency=medium

  [ Ural Tunaboyu ]
  * adt_testbed: always attempt to detect release

  [ Paride Legovini ]
  * Save artifacts in a per-test directory (Closes: #903696)
  * tests: fix mock apt-cache in test_apt_source_single_line_package_list
  * tests: move test_tree_build_needed_success under DebTestsVirtFS
  * a-virt-lxd: replace --vm with detection of the image type
  * a-buildvm-ubuntu-cloud: do not add a foreign architecture
  * runner/autopkgtest: drop unnecessary testbed reset/cleanup
  * setup-testbed: include wireless interfaces in search for default iface
  * d/control: bump Standards-Version to 4.7.0, no changes needed
  * d/control: drop redundant Rules-Requires-Root: no

  [ Johannes Schauer Marin Rodrigues ]
  * virt/autopkgtest-virt-unshare: ignore /etc/skel from outside the chroot
    when creating user's home directories inside the chroot with --prefix

  [ Chad Smith ]
  * fix(setup-testbed): avoid deprecated cloud-config apt_preserve_sources_list

 -- Paride Legovini <paride@debian.org>  Thu, 11 Dec 2025 16:17:37 +0100

autopkgtest (5.52) unstable; urgency=medium

  [ Paride Legovini ]
  * Fix Launchpad owner validation in PPA sources.
    Thanks to Marco Trevisan (3v1n0)
  * d/t/control unshare: add missing distro-info test dependency.
    Thanks to Athos Ribeiro (LP: #2126690)
  * build-lxd: pass setup-script, await-boot via pipe instead of redirect
  * setup-testbed: add motd-news-config to the list of packages to purge
  * pre-commit: bump ruff-pre-commit pinned version, no changes needed

  [ Antonio Terceiro ]
  * Document how to work on tests without needing to rebuild (Closes: #1000802)

  [ Christian Kastner ]
  * qemu: Implement arbitrary host directory sharing

  [ Paul Gevers ]
  * tests: drop have_apt code fragment unused since commit 6ac81a0
  * doc: explain how one can run with sysvinit in a VM (Closes: #844123)
  * doc: mark skip-not-installable as deprecated

  [ Frode Nordahl ]
  * setup-testbed: Ensure lxd-agent-loader is retained when present in image
    (LP: #2127063).

  [ Simon McVittie ]
  * d/control, d/tests/control: Depend on bsdutils when running tests
    (Closes: #1118417)

  [ Jochen Sprickerhof ]
  * unshare: add --mirror option

 -- Paride Legovini <paride@debian.org>  Sun, 16 Nov 2025 23:04:59 +0100

autopkgtest (5.51) unstable; urgency=medium

  [ Paride Legovini ]
  * Assume the base testbed release to be the one providing base-files
    Related changes:
    - Update APT index individually for newly added sources
    - t/mockup-commands: implement fake apt-cache policy
    - d/autopkgtest: adapt tests to new release detection logic
    - get-release: drop script, superseded by new release detection logic
    - autopkgtest(1) update documentation on how the testbed release is detected
  * build-qemu/docker: don't use archive.ubuntu.com for LTS releases
  * Run ps(1) on leaked processed only if ps(1) is available.
    Thanks to Ferenc Wágner (Closes: #1112625)
  * a-b-lxd: honor the lxd remote when cleaning up old images
  * CI:
    - Run Ubuntu Salsa CI on Questing (current devel release)
    - Salsa CI: disable the autopkgtest i386 job
    - Bump timeout for the lxc jobs

  [ Jochen Sprickerhof ]
  * unshare: cleanup temporary tarball at exit

  [ Helmut Grohne ]
  * Testbed: fix apt pinning for old apt releases

 -- Paride Legovini <paride@debian.org>  Mon, 08 Sep 2025 15:49:09 +0200

autopkgtest (5.50) unstable; urgency=medium

  [ Paride Legovini ]
  * nova: fix failure to delete server detection logic
  * copyupdown: use subprocess.DEVNULL instead of open('/dev/null')
  * execute_timeout(): automatically pipe to stdin when instr is passed
  * check_exec(): support feeding string to stdin of executed command
  * wait_booted(): pass the await-boot script to stdin of sh -s
  * await-boot: do not systemctl start network-online.target
  * setup-testbed: restrict search of main network iface to Ethernet devices
  * autopkgtest-virt-ssh: wait for boot to complete
  * wait_booted: add "boot completed" debugging printout
  * await-boot: if cloud-init is installed, wait for it to complete
  * Clarify debug messages about communication with the virt server
  * a-v-ssh: print setup command stderr in real time
  * nova: drop duplicate "wait for ssh" and "wait for cloud-init" logic
  * a-v-ssh wait_for_ssh: demote "ssh connection failed" to a debug message
  * a-virt-ssh: reimplement hook_wait_reboot around the system boot_id
  * Fix object queried for the "insecure" attribute
  * Ignore duplicate commas when splitting dependency strings
  * setup-testbed: mark some packages as manually installed
  * setup-testbed: remove ubuntu-pro-client as part of the image cleanup
  * test_timeout_no_output: make test work with non-GNU coreutils (LP: #2117709)
  * a-b-ubuntu-cloud: do not install ubuntu-minimal
  * setup-testbed: mark iproute2 as manually installed
  * Fix not-is-test pycodestyle error spotted by ruff (E714)
  * a-b-ubuntu-cloud: replace syntax that requires a too new Python version
  * Fix Launchpad username validation in PPA sources (LP: #2119533)
  * Apply ruff formatting

  [ Helmut Grohne ]
  * incus: clear /etc/machine-id in base image
  * setup-testbed: improve systemd-networkd detection

  [ Simon Chopin ]
  * buildvm-ubuntu-cloud: make it easy to add packages to the image

  [ Antonio Terceiro ]
  * setup-testbed: only run update-initramfs if it exists

  [ Simon McVittie ]
  * build-qemu: Don't require qemu-i386-static to build i386 VM on amd64
  * setup-testbed: Use archive.debian.org for archived buster security updates
  * build-docker: Default to archive.debian.org for EOL releases
    (Closes: #1083163)
  * build-docker: Use old-releases.ubuntu.com for EOL Ubuntu releases
  * build-qemu: Use archive.debian.org for EOL Debian releases

  [ Luca Boccassi ]
  * Use 'systemctl reboot' instead of 'reboot' with systemd

 -- Paul Gevers <elbrus@debian.org>  Mon, 25 Aug 2025 20:30:12 +0200

autopkgtest (5.49) unstable; urgency=medium

  * NEWS.Debian: Document the security fixes in 5.48.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Wed, 16 Apr 2025 19:41:19 +0100

autopkgtest (5.48) unstable; urgency=medium

  [ Ural Tunaboyu ]
  * Makefile: install arch-is-concerned.pl.  Fixes testing on very
    old distros with very old python3-debian.

  [ Ian Jackson ]
  * SECURITY: autopkgtest-virt-*: Don't make downtmp dangerously world-writeable
  * SECURITY: Fix mode (permissions) of AUTOPKGTEST_ARTIFACTS
  * SECURITY: autopkgtest-virt-null: Do not advertise isolation-machine
  * SECURITY: Fix autopkgtest-virt-unshare to not advertise downtmp-host
  * SECURITY: Only chmod copied-down things world-writeable with --insecure
  * autopkgtest-virt-null: Add --fake-capabilities option
  * Clarify that mangling config in $HOME is breaks-testbed
  * No suggested-normal-user without root-on-testbed
  * If necessary, chown the scratchspace to the normal user
  * Introduce autopkgtest --insecure option
  * d/t/control: Declare isolation-container for tests/autopkgtest
  * Centralise downtmp and capabilities
  * autopkgtest-virt-qemu: Move the base caps list to a global
  * Make downtmp-host= cap filtering more careful

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 14 Apr 2025 00:31:53 +0100

autopkgtest (5.47) unstable; urgency=medium

  [ Ian Jackson ]
  * README.virtualisation-server: Fix and document a URL decoding rune
  * autopkgtest-virt-null: New --retain-tmp option (Closes: #1092771)

  [ Sean Whitton ]
  * build-podman: Accept additional arguments for 'podman build'
  * build-podman: Fix accepting additional arguments on bookworm
  * build-docker, build-docker(1): Update docs to match argparse reality

  [ Jochen Sprickerhof ]
  * unshare: support UNRELEASED as release name (Closes: #1099126)
  * unshare: call mmdebstrap with --mode=unshare (Closes: #1099578)

  [ Arnaud Rebillout ]
  * Fix setup-testbed for Kali Linux

 -- Paride Legovini <paride@debian.org>  Tue, 11 Mar 2025 13:09:57 +0100

autopkgtest (5.46) unstable; urgency=medium

  [ Jochen Sprickerhof ]
  * setup-testbed: exclude sid from security (Closes: #1099053)

 -- Paride Legovini <paride@debian.org>  Thu, 27 Feb 2025 18:46:41 +0100

autopkgtest (5.45) unstable; urgency=medium

  [ Jochen Sprickerhof ]
  * unshare: support repeated open and close commands (Closes: #1094633)
  * unshare: error out if neither --release nor a chroot is provided
    (Closes: #1096123)

  [ Antonio Terceiro ]
  * setup-testbed: consistently apply eatmydata to all apt operations

  [ Paride Legovini ]
  * Don't pin package under test if required capabilities are missing
    (Closes: #1095979)
  * setup-testbed: fix shell redirect so that it points to the chroot
  * setup-testbed: fix out-of-chroot bug in deb822 detection
  * setup-testbed: fix typo: /etc/network/interface -> interfaces
  * adt_binaries: silence stderr from `apt-get indextargets`, fixing
    publication of built binaries on Debian Jessie and Ubuntu Trusty LTS
  * setup-testbed: fix recovery of backed-up resolv.conf

  [ Simon McVittie ]
  * runner: If we installed packages to unpack source, revert the testbed
    before starting to run tests (Closes: #1098646)
  * docker: Document minimal content for the image/tarball

  [ Paride Legovini ]
  * Do not turn test deps from package under test into versioned deps.
    This reverts the change mentioned to fix #1052119 in version 5.44.

  [ Jochen Sprickerhof ]
  * setup-testbed: Add debian-security for Debian releases
    (Closes: #1071185, #1055370)

 -- Paride Legovini <paride@debian.org>  Wed, 26 Feb 2025 17:43:40 +0100

autopkgtest (5.44) unstable; urgency=medium

  [ Simon McVittie ]
  * tests: Normally only test timeouts on known-fast architectures.
    We cannot make these test-cases reliable on slower machines like riscv64
    without making the test suite take a long time even on faster machines.
    (Closes: #1093275)
  * virt-podman: Don't crash if the selected image has no labels
    (Closes: #1093546)
  * virt-podman(1): Mention how to generate images locally
  * build-podman(1): Consistently use podman in examples
  * virt-podman(1): Document that full systemd functionality needs
    CAP_SYS_ADMIN, how to obtain it, and the security considerations that
    mean it is not the default (Closes: #1078205)
  * d/control: Remove obsolete alternative dependency on pep8
    (Closes: #1093161)
  * d/README.source: Mention some apt features that we cannot use yet
  * build-docker(1): Clarify the relationship between --tarball and --image.
    In particular clarify the circumstances under which a base image
    for use inside the container environment will be downloaded from a
    third-party container registry.

  [ Paride Legovini ]
  * Turn test dependencies from package under test into strictly versioned
    dependencies (Closes: #1052119)
  * d/t/schroot: use eatmydata in the test schroot to speed up testing
  * autopkgtest(1): clarify usage of virt servers, suggest qemu
  * virt-schroot(1): add warning regarding lack of isolation

  [ Ural Tunaboyu ]
  * buildvm-ubuntu-cloud: Don't exclude documentation

  [ Jochen Sprickerhof ]
  * Add test dependency on apt to make it reproducible
  * virt-unshare: Keep apt lists when bootstrapping

  [ Florent 'Skia' Jacquet ]
  * buildvm-ubuntu-cloud: Use server image for riscv64 testbeds, since
    no minimal image is available

  [ Ian Jackson ]
  * virt-*: Exit with an error if stdin is in non-blocking mode
  * virt-*: Exit on EOF (Closes: #1094634)
  * virt-*: Warn on (invalid) leading whitespace in the
    virtualization protocol
  * virt-*: Reject empty commands

 -- Simon McVittie <smcv@debian.org>  Wed, 12 Feb 2025 14:47:41 +0000

autopkgtest (5.43) unstable; urgency=medium

  [ Steve Langasek, Paride Legovini ]
  * Add support for foreign-architecture testing.
    A typical use-case for this is testing an i386 package in an amd64
    container.

  [ Paride Legovini ]
  * Use python3-debian to do more correct architecture matching, with a
    perl fallback used if python3-debian is too old (Closes: #1086538)
  * Make pins cover any architecture for better multi-arch support
    (Closes: #1088971)
  * Add sources specified via --add-apt-source after configuring pockets.
    This way autopkgtest does not add pockets to PPAs, which is not
    desired. (LP: #2091393)
  * Support adding apt sources from file (--add-apt-source=FILENAME)
    (Closes: #1089736)
  * Fix parsing of `apt-cache policy` output if it has phasing info
  * build-lxd: bump boot timeout from 1 minute to 5 minutes, which is
    helpful on armhf
  * d/t/control: re-sort with wrap-and-sort from devscripts 2.24.8.
    wrap-and-sort from devscripts 2.24.8 changes the sorting algorithm
    for packages, see #1049943. Update d/t/control accordingly.
  * binaries: reinstall binaries using _run_apt_command().
    This reduces duplication, and ensures that
    DEBIAN_FRONTEND=noninteractive is set. (Closes: #1092621)

  [ Simon McVittie ]
  * qemu: Prefer to use /etc/localtime to copy host time zone into VMs
    (Closes: #1038835)
  * build-docker: Add a default command (bash) for images with --init=none,
    for convenient interactive reuse
  * tests: Remove some problematic environment variables.
    In particular, when autopkgtest itself (an Architecture: all package)
    is built, we must not allow internal variables set by debhelper to
    propagate into the Architecture: any packages that are built and
    tested by autopkgtest's test suite, because that will make them fail
    to build.

  [ Florent 'Skia' Jacquet ]
  * Only use deb822 apt sources if apt is 2.3.10 or later (Debian 12,
    Ubuntu 22.04), fixing a regression for --add-apt-source=ppa on
    Ubuntu 20.04 'focal'
  * ssh-setup/nova: improve logging for easier use of grep

  [ Colin Watson ]
  * Install passwd for needs-sudo

  [ Ural Tunaboyu ]
  * d/t/schroot: run schroot tests in Ubuntu chroots if the host is Ubuntu
  * setup-testbed: ensure /tmp is deleted on reboot, matching the behaviour
    we would see with a tmpfs

  [ Jochen Sprickerhof ]
  * unshare: run a configurable bootstrap command, defaulting to
    mmdebstrap, if no suitable chroot was found

  [ Tim Andersson ]
  * ssh-setup/nova: Improve robustness of cleanup

  [ Helmut Grohne ]
  * setup-testbed: Don't treat an empty /etc/network/interfaces as
    implying that systemd-networkd and ifupdown are not in use
  * setup-testbed: If systemd-networkd is enabled, do not configure
    ifupdown. No further configuration is needed if host0 networking is
    configured via /usr/lib/systemd/network/80-container-host0.network.
    (Closes: #1090884)

  [ Paul Gevers, Simon McVittie ]
  * tests: adapt for change in dpkg regarding Rules-Requires-Root.
    With the latest changes in dpkg, debhelper will no longer call the
    'build' target if it doesn't need it. Hence the checks in several
    of our tests need to be updated to check that 'binary' is called.
    (Closes: #1092086, #1092398)

  [ Julian Gilbey, Simon McVittie ]
  * README.package-tests.rst: Clarify the interactions between Testsuite,
    dpkg and autodep8 (Closes: #1016008)

 -- Simon McVittie <smcv@debian.org>  Wed, 15 Jan 2025 09:07:55 +0000

autopkgtest (5.42) unstable; urgency=medium

  [ Stefano Rivera ]
  * Correct logic in old-systemd fallback code

  [ Paride Legovini ]
  * Handle multi-line --add-apt-sources (used by debci)
  * tests: add test for multi-line --add-apt-sources

 -- Paride Legovini <paride@debian.org>  Fri, 25 Oct 2024 10:04:32 +0200

autopkgtest (5.41) unstable; urgency=medium

  * If autopkgtest fails to detect the testbed release, exit with error only
    if there are command line arguments which actually require knowing the
    testbed release (namely: --add-apt-release, --apt-pocket).
  * Make the "get apt sources from testbed" code more solid. Changes:
    - Don't fail if there is no /etc/apt/sources.list
    - Don't fail if there are .list files, but none defines a "deb" source
    - Move the sources extraction code to standalone shell scripts
    Thanks to Florent 'Skia' Jacquet
  * tests: expand --add-apt-release / --apt-pocket tests, deb822 case

 -- Paride Legovini <paride@debian.org>  Wed, 23 Oct 2024 16:38:56 +0200

autopkgtest (5.40) unstable; urgency=medium

  [ Johannes Schauer Marin Rodrigues ]
  * lib/adt_binaries.py: run 'apt update' before 'apt install'

  [ Simon McVittie ]
  * build-qemu(1): Separate recommended and deprecated invocation
  * build-lxc, build-lxd: Convert command-line parsing to Python
  * build-lxc: Check presence of lxc-templates
  * build-docker: Label Docker/Podman images with some of their properties
  * virt-podman: Try to enable --init automatically if it would work
  * build-docker: Tag images for default architecture with/without prefix

  [ Paride Legovini ]
  * Implement support for adding PPAs via --add-apt-source=ppa:OWNER/PPA
  * Refactor and improve "get priority from apt policy" logic
  * Rework and simplify the package pinning logic
    - man: clarify documentation on how pinning works
  * Refactor handling of synthesized dependencies
  * Get the testbed release from the APT data sources
  * Always get the testbed release when setting up the testbed
  * Trust find_source_version_to_download even in presence of src: pins
  * Refactor how APT releases and pockets are added
    - Handle sources.list [ options ] when doing --add-apt-release
    - Update manpage after refactor of APT source addition
  * Refactor _run_apt_install() and rename to _run_apt_command()
    - Handle --apt-upgrade via _run_apt_command() (Closes: #1011204)
    - Update testbed package index (apt-get update) using _run_apt_command()
  * Revert "lxc: define /tmp mount via lxc-start"
  * build_source: do not generate debug symbol packages
  * build_source: do not build udeb packages
    - tests: test that nocheck, noudeb profiles are set at build time
  * tests: check if CAP_SYS_ADMIN is EFFECTIVE (Closes: #1079216)
  * tests: Archive: support specifying the release Codename
  * tests: Archive: add support for accessing dists via codename
  * tests: Archive: rename series to suite, require more explicit config
  * tests: test_apt_pocket_pkg_with_proposed_dep: use expect_success=True
  * tests: expand the pocket tests to cover --add-apt-release --pin-packages
  * tests: run the apt_pocket tests with NotAutomatic: yes in -proposed
  * tests: add test_debian_layout_* to test pinning on a Debian-like layout
  * tests: add new test: test_offline_success
  * tests: ChrootRunner: get testbed_apt_version from the chroot
  * tests: mockup-commands: bump version of mock apt command
  * d/control: move python3-distro-info from Suggests to Depends
  * pre-commit: add rst-* hooks from pygrep-hooks
  * CI: add Salsa CI pipeline recipe for Ubuntu

  [ Stefano Rivera ]
  * incus/lxd: Set a default value for PATH

  [ Guilhem Moulin ]
  * build-qemu: Turn off ‘orphan_file’ for older target suites
    (Closes: #1078760)

  [ Lee Garrett ]
  * Increase msize for 9p mount to 512KB (~30% read performance increase)

  [ Ural Tunaboyu ]
  * t/autopkgtest-buildvm-ubuntu-cloud: add check for required space
  * t/autopkgtest-buildvm-ubuntu-cloud: fix image url for some arches
    (LP: #2077552)
  * t/autopkgtest-buildvm-ubuntu-cloud: add image cache (LP: #2073938)
  * lib/autopkgtest_deps: add dependency for package
  * lib/autopkgtest_deps: add dependency for directory
  * t/autopkgtest-buildvm-ubuntu-cloud: add directory dependency on output_dir
  * tests/autopkgtest: make test_apt_source_arch_conflict pass on non-amd64
  * debian/tests: enable lxd tests for all arches for which there are images

  [ Blair Noctis ]
  * lib/testdec: use lists in dep set manipulation (Closes: #1080981)
  * tests/testdesc: test recommends from multiple packages

  [ Kai Oberbeckmann ]
  * qemu: Fix boot of UEFI-only virtual machines (Closes: #1081374)

  [ Christian Kastner ]
  * reboot-required: Also monitor /boot/{grub,efi}

  [ Paul Gevers ]
  * VirSubproc.py: prevent UnboundLocalError on timeout

  [ Antonio Terceiro ]
  * autopkgtest-build-lxc: avoid lxc-attach messing with file permissions

 -- Paride Legovini <paride@debian.org>  Mon, 21 Oct 2024 12:09:29 +0200

autopkgtest (5.39) unstable; urgency=medium

  [ Paride Legovini ]
  * d/tests/lxd: drop racey workaround for the images: remote url,
    depend on a new enough lxd instead (Closes: #1078216)
  * d/control: bump Standards-Version to 4.7.0, no changes needed
  * Drop --testname argument, deprecated in 2017
  * a-v-unshare: create user with useradd --prefix instead of --root,
    to avoid chrooting into an environment that does not yet have /dev
    (Closes: #1077988)
  * Stop skipping d/t/unshare on Ubuntu, no longer necessary with the
    above a-v-unshare change
  * d/t/unshare: run tests in an Ubuntu testbed when host system is Ubuntu

  [ Ural Tunaboyu ]
  * autopkgtest-buildvm-ubuntu-cloud: improve dependency checks
    (LP: #2073938)

  [ Simon McVittie ]
  * virt-qemu: Work around #1072004 in 9pfs.
    Thanks to Dominique Martinet (Closes: #1071456) (Mitigates: #1072004)
  * build-podman: Don't assume that host is reachable as 10.0.2.2,
    which is no longer true when podman uses passt (Closes: #1078076)
  * qemu: Refactor to allow detection of dependencies
  * qemu: Update lists of architectures (Helps: #1062026)
  * build-*, virt-qemu, virt-docker/virt-podman, virt-lxc,
    virt-lxd/virt-incus: Check for (most) dependencies
    (Closes: #1021776, #1034351, #1039958, #1076739)
  * build-docker/build-podman, build-qemu: Fix running from source tree
  * tests: Skip tests involving mount points if we don't have
    CAP_SYS_ADMIN, for example in rootless podman (Closes: #1078215)
  * d/README.source: Mention the minimum Python version in testbeds (3.4)
  * d/control, d/tests/control: /usr/bin/docker is now in docker-cli
    (see also #1078269)
  * d/tests/control: Install passt along with newer podman versions
  * tests: Use a Debian mirror to test handling of persistent apt failures

  [ Jochen Sprickerhof ]
  * unshare: Make the chroot more minimal (mmdebstrap --variant=apt)

  [ Luca Boccassi ]
  * await-boot.sh: Make the check for systemd-sysv robust against tests
    that install a different init system (Closes: #1078510)

  [ Paul Gevers ]
  * wrapper.sh: Convert test exit codes 254 and 255 to 253, preventing
    misinterpretation as a testbed failure (Closes: #1078214)

  [ Johannes Schauer Marin Rodrigues ]
  * doc/README.package-tests.rst: Use a better example test name
  * doc/README.package-tests.rst: A test name cannot contain commas

 -- Simon McVittie <smcv@debian.org>  Mon, 12 Aug 2024 12:11:05 +0100

autopkgtest (5.38) unstable; urgency=medium

  [ Paride Legovini ]
  * t/autopkgtest-build-docker: use ports.ubuntu.com on non-amd64 Ubuntu
  * t/autopkgtest: test_git_source_build: skip if remote repo is unreachable
  * d/t/unshare: add skip-not-installable restriction
  * d/t/lxd: restrict architectures via Architecture and enable arm64
  * d/tests: always use annotate-output to disambiguate test output
  * VirtSubproc wait_booted(): ignore timeouts within the retry loop
  * t/autopkgtest: LxcRunner: get the testbed apt version via lxc-execute
  * tests/autopkgtest: better handling of testbed_apt_version
  * r/autopktest: get_max_priority_from_policy support any priority
  * await-boot.sh: use systemd better and use script in a-build-lxc/lxd.
    Thanks to Luca Boccassi

  [ Colin Watson ]
  * Maintain container and VM Incus images in parallel

  [ Florent 'Skia' Jacquet ]
  * nova: allow more retries for quota issues
  * t/a-b-ubuntu-cloud: install 'ubuntu-minimal' and autoremove extra packages
  * t/a-b-ubuntu-cloud: make sure installing packages never prompts

  [ Paul Gevers ]
  * Revert "tests: completely disable podman-init autopkgtest as it fails nasty"
  * create-normal-user: redirect stderr to stdout for adduser/useradd

  [ Simon McVittie ]
  * autopkgtest-build-docker: Avoid repeated localhost/ when using podman
  * autopkgtest-build-docker: Allow importing a pre-prepared minbase

 -- Paul Gevers <elbrus@debian.org>  Sat, 03 Aug 2024 20:43:22 +0200

autopkgtest (5.37) unstable; urgency=medium

  [ Jochen Sprickerhof ]
  * Avoid empty string for apt satisfy

 -- Paride Legovini <paride@debian.org>  Mon, 24 Jun 2024 10:01:03 +0200

autopkgtest (5.36) unstable; urgency=medium

  [ Paul Gevers ]
  * Fix typo in the changelog

  [ Paride Legovini ]
  * Changes in source package selection:
    - Truly honor pinning when looking for the source package to download
    - find_source_version_to_download: always check the src package name
      (LP: #2066290)
  * Changes in test depependencies resolution:
    - Drop redundant dependency parsing via perl Dpkg::Deps
    - Leave dependency parsing to apt when possible
  * virt-lxc: cleanup: force destroy container without stopping it
  * build-needed: build with DEB_BUILD_PROFILES=nocheck
  * setup-testbed: prevent /tmp from getting a tmpfs mount (LP: #2069834)
  * tools/a-b-ubuntu-cloud: stick with the default locale
  * tools/a-b-ubuntu-cloud: move away from deprecated cloud-init keys
  * t/autopkgtest: move the SchrootRunner tests under LxcRunner
  * t/autopkgtest: make test_apt_pocket_disjoint_binaries cover more cases
  * tests: build packages with gzip compression for trusty compatibility
  * d/t/lxd: update URL for images: remote on old LXD
  * d/t/lxd: run tests on a Debian testing testbed

  [ Florent 'Skia' Jacquet ]
  * setup-testbed: don't install 'Recommends' for 'linux-generic'
  * t/a-buildvm-ubuntu-cloud: use minimal image where possible

  [ Christian Kastner ]
  * autopkgtest-virt-qemu: Fix command prompt waiting (Closes: #1071533)
  * qemu: Drop ifupdown from image creation
    It's already installed during debootstrapping, if necessary.
  * setup-testbed: Add support for netplan.io networking
    (Closes: #960729) (LP: #2060187)

  [ Evgeni Golov ]
  * assume remote docker when running inside docker

  [ Agathe Porte ]
  * qemu: fix warning: short-form boolean option 'readonly' deprecated
    (Closes: #1073930) (LP: #2069957)

 -- Paride Legovini <paride@debian.org>  Fri, 21 Jun 2024 14:28:38 +0200

autopkgtest (5.35) unstable; urgency=medium

  [ Christian Kastner ]
  * qemu: Drop ifupdown from image creation

  [ Florent 'Skia' Jacquet ]
  * tools/a-b-lxd: make sure the reboot happens when needed
  * ssh-setup/nova: explicitly set 'fqdn' in cloud-init

  [ Paride Legovini ]
  * install_apt: drop broken debugging stage
  * find_source_version_to_download: do not consider udebs
  * Resolve and install test dependencies using apt-get satisfy
  * d/control: bump Build-Depends: python3 to >= 3.8
  * d/control: bump versioned Suggests: vmdb2 to >= 0.25-1.
    Thanks to Christian Kastner
  * d/control: drop build-dependency on python3-mock (Closes: #1060447)
  * d/control: make Build-Depends required by tests <!nocheck>
  * tests: add pre-commit-config and yamllint configuration
  * tests: unshare: skip test (exit 77) if simple unshare command fails
  * tests: unshare: skip test if kernel.apparmor_restrict_unprivileged_userns=1
  * tests: docker: make the docker daemon inherit the proxy settings
  * tests: schroot: use default value (DIRECT) for $https_proxy
  * tests: when dpkg-vendor is Ubuntu, test on Ubuntu containers
  * tests: make the lxd test work on Ubuntu
  * Assume that if root-on-testbed then we can use apt (Closes: #1042971)
  * autopkgtest-build-lx*: fix shellcheck warnings and check in pre-commit
  * ssh-setup/nova: fix shellcheck warnings and check in pre-commit

  [ Frode Nordahl ]
  * autopkgtest-build-lxd: Extract lxc client version correctly.
    (LP: #2069274, LP: #2069283)
  * autopkgtest-build-lxd: Add missing remote prefix in get_boot_id().

  [ Paul Gevers ]
  * runner/autopkgtest: virt-ssh gets confused by newlines in create_command
  * tests: skip test_copy_timeout (Addresses: #1068363)

  [ Luca Boccassi ]
  * lxc: define /tmp mount via lxc-start

 -- Paul Gevers <elbrus@debian.org>  Sun, 12 May 2024 09:27:10 +0200

autopkgtest (5.34) unstable; urgency=medium

  [ Victor Westerhuis ]
  * Let vmdb2 write /etc/fstab in autopkgtest-build-qemu

  [ Nick Rosbrook ]
  * add support for deb822 sources (LP: #2052639)

  [ Julian Andres Klode ]
  * ssh: Set ConnectionAttempts=20 in auxverb
  * lxd: Increase various timeouts

  [ Paride Legovini ]
  * install_apt: drop retry loop on AptDownloadError
  * build-dep: improve error handling
  * runner: rely on package versions to select which src package to download

  [ Paul Gevers ]
  * autopkgtest-build-lxc: repair proxy detection for lxc.network deprecation
    (Closes: #1067406)
  * autopkgtest-build-lxc*: add support to not have apt proxy autodetected
    (Closes: #933064)

  [ Antonio Terceiro ]
  * autopkgtest-virt-lxc: add option to choose container location

 -- Paride Legovini <paride@debian.org>  Wed, 03 Apr 2024 11:06:34 +0200

autopkgtest (5.33) unstable; urgency=medium

  [ Antonio Russo ]
  * virt-schroot: config, val splits on = exactly once

  [ Frode Nordahl ]
  * autopkgtest-build-lxd: Await boot before setup on VM build.
  * autopkgtest-build-lxd: Add remote support.

  [ Paul Gevers ]
  * autopkgtest-virt-lxc: remove ancient code path
  * tests: completely disable podman-init autopkgtest as it fails nasty

  [ Arnaud Rebillout ]
  * setup-testbed: Add non-free-firmware component for Debian and Debian-like

  [ Paride Legovini ]
  * On package build, use apt-get build-dep (if available on the testbed)
  * Assume that dpkg-query (which is Essential) is available
  * Makefile: fully clean package build artifacts
  * autopkgtest-build-lxd: fix unbound variable error
  * autopkgtest-buildvm-ubuntu-cloud: drop workaround for LP: #1427999
  * autopkgtest-buildvm-ubuntu-cloud: default to 2GB of RAM (LP: #1973628)
  * CI: include jobs from the salsa-ci-team Debian pipeline
  * CI: also run the NullRunner-like tests on the Ubuntu devel release
  * Add myself to Uploaders

  [ Christian Kastner ]
  * qemu: Don't attempt poweroff on uninitialized VM

  [ Florent 'Skia' Jacquet ]
  * d/t/unshare: make test runnable on Ubuntu
  * l/adtlog: fix deadlock when low on free space
  * tests: add a testcase for testbed deadlock when running low on free space

  [ Iain Lane ]
  * ssh-setup/nova: Use `openstack network show` in preference to `nova`

  [ Stefano Rivera ]
  * Document some more possible errors in summary (Closes: #1059881)

  [ Luca Boccassi ]
  * apt build-dep: use --env (Closes: #956931)

  [ Heinrich Schuchardt ]
  * qemu: use device-tree for booting riscv64 (LP: #2056764)
  * qemu: boot riscv64 via EFI (LP: #2056764)

 -- Paride Legovini <paride@debian.org>  Thu, 14 Mar 2024 12:18:38 +0100

autopkgtest (5.32) unstable; urgency=medium

  [ Florent 'Skia' Jacquet ]
  * d/t/schroot: better use of existing variables
  * d/t/schroot: allow running behind a proxy

  [ Simon McVittie ]
  * testarchive: Fix a pycodestyle warning
  * Standards-Version: 4.6.2 (no changes required)
  * qemu: Use 4M OVMF images if available

  [ Stefano Rivera ]
  * Testbed: Kill with SIGKILL if SIGTERM doesn't do the job in 10 seconds
    (Closes: #1059444)

  [ Paul Gevers ]
  * tests: increase sleep in test_timeout() for lxd test (Closes: #1020634)
  * autopkgtest-virt-qemu: raise time for command prompt return
  * virt-qemu: add context to several timeout errors

  [ Michael Biebl ]
  * Bump default ram-size for virt-qemu to 2048 (Closes: #1059840)

  [ Colin Watson ]
  * Add Incus support

  [ Santiago Ruano Rincón ]
  * Make autopkgtest-build-qemu pass mirror info to setup-testbed
    (Closes: #1060426)

  [ Paul Gevers ]
  * tests: increase --timeout-build to accommodate for riscv64
  * tests: mark podman-init autopkgtest flaky for now

 -- Paul Gevers <elbrus@debian.org>  Thu, 11 Jan 2024 14:06:22 +0100

autopkgtest (5.31.2) unstable; urgency=medium

  [ Florent 'Skia' Jacquet ]
  * d/control: add genisoimage as suggested package.
    It's used in `autopkgtest-buildvm-ubuntu-cloud`.

  [ Paul Gevers ]
  * autopkgtest-build-qemu: drop use of qemu-debootstrap.
    This is not needed in Debian 11 or newer. (Closes: #1038826)

  [ Simon McVittie ]
  * d/rules: Don't fail the build if a lint check fails (Closes: #1058550)
  * qemu, testdesc: Convert "# type:" comments into variable annotations.
    This avoids unused import warnings with current versions of pyflakes.

 -- Simon McVittie <smcv@debian.org>  Sun, 24 Dec 2023 16:50:37 +0000

autopkgtest (5.31.1) unstable; urgency=medium

  * runner: fix architecture wildcard support broken in 30d5aa7
  * runner: fail badpkg in case no source was found like before 30d5aa7

 -- Paul Gevers <elbrus@debian.org>  Sun, 12 Nov 2023 21:35:20 +0100

autopkgtest (5.31) unstable; urgency=medium

  [ Johannes Schauer Marin Rodrigues ]
  * lib/autopkgtest_qemu.py: use -machine type=virt,gic-version=max when
    running natively on arm64 for kvm acceleration

  [ Tim Andersson ]
  * add ssh connect timeout to ssh-setup/nova
  * setup-testbed: Set apt error mode as any

  [ Paul Gevers ]
  * adt_testbed: factor out add-apt-sources
  * adt_testbed: factor out get-default-release
  * adt_testbed: factor out shell code to create sources.lists
  * Rewrite of source version selection in Python
  * create-sources.list-for-pocket: minor logical improvements
  * add-apt-sources: some checks of input arguments

  [ Jochen Sprickerhof ]
  * Update resolv.conf in unshare chroot

  [ Samuel Thibault ]
  * Fix hyphens in manpages

  [ Mateus Rodrigues de Morais ]
  * Add --cpus to buildvm-ubuntu-cloud tool

  [ Christian Kastner ]
  * qemu: Add option to poweroff gracefully

 -- Paul Gevers <elbrus@debian.org>  Mon, 06 Nov 2023 20:40:32 +0100

autopkgtest (5.30) unstable; urgency=medium

  [ Christian Kastner ]
  * Set umask while initializing DebBinaries, fixing permissions errors
    when running virt-podman with a restrictive umask (Closes: #1032487)

  [ Helmut Grohne ]
  * virt-qemu: Use a lock file to resolve a race condition when allocating
    a port for ssh
  * build-{qemu,lxc}, buildvm-ubuntu-cloud: Explicitly pass RELEASE to
    setup-testbed when known
  * build-qemu: Don't use ext4 features unsupported in the target release

  [ Jochen Sprickerhof ]
  * qemu: Better riscv64 support
    - Use -machine=virt on riscv64
    - Specify a riscv64-compatible network device for all architectures

  [ Stefano Rivera ]
  * build-lxd: Explicitly reuse aliases with lxd >= 5.14, which will no
    longer overwrite an existing alias by default

  [ Simon McVittie ]
  * d/README.source: Add a policy for autopkgtest dependencies:
    - Host system: aiming to support latest Debian stable or Ubuntu LTS,
      and the previous stable/LTS if it's straightforward to do so
    - Testbed: aiming to support Debian 8+ or Ubuntu 14.04+
  * testbed: Use sudo -n true instead of sudo -n -v to detect
    ability to run sudo without password, resulting in it being detected
    successfully in more cases
  * testbed: Move more environmental setup into wrapper.sh
  * testbed: Factor out Perl code to parse dependencies
  * setup-testbed:
    - Remove code that was only needed for Ubuntu 12.04 on armhf
    - Only auto-detect RELEASE, MIRROR when necessary
  * tests:
    - Add a convenience `make check` target
    - Fix a failing qemu test
    - Run more tests in CI and during package build
    - d/tests/lxd: Fix test failure by installing recommended dnsmasq-base
      package
    - d/tests/lxd: Use stable image, fixing testing while
      images.linuxcontainers.org doesn't provide an image for trixie yet
    - Remove stale reference to SchrootClickRunner tests, which were removed
      in mid 2022
    - CI: Use testing instead of unstable, to avoid temporary regressions
      such as #1042498
    - CI: Test the unshare backend on stable instead of unstable
    - CI: Run basic tests on Debian 11
  * Fix some shellcheck warnings

  [ Paride Legovini, Simon McVittie ]
  * testbed: Install satdep using apt-get install /path/to/*.deb if possible
    (apt >= 1.1, available in Debian 9+ or Ubuntu 16.04+), falling back to
    using dpkg --unpack and apt-get -f install as before for Debian 8 and
    Ubuntu 14.04

  [ Gioele Barabucci ]
  * lib/VirtSubproc: Use explicit paths for commands in downtmp,
    fixing testbed failure if the default shell is changed to busybox
    during testing

  [ Antonio Terceiro ]
  * Add --timeout option, which sets a global timeout for all commands
    that are controlled by the source package being tested
    (the build if the needs-build restriction is present, and the tests
    themselves).

  [ Raphaël Hertzog ]
  * debian: Depend on mawk >= 1.3.4 for systime() function, required
    since 5.29

 -- Paul Gevers <elbrus@debian.org>  Sun, 30 Jul 2023 19:31:21 +0200

autopkgtest (5.29) unstable; urgency=medium

  [ Brian Murray ]
  * Fix a typo

  [ Paride Legovini ]
  * Prevent --apt-pocket from setting the wrong default release
    (Closes: #1032314) (LP: #2009191)

  [ Antonio Terceiro ]
  * autopkgtest-virt-lxc: call timeout sudo instead of sudo timeout

  [ Helmut Grohne ]
  * autopkgtest-build-qemu: add --keyring argument
  * autopkgtest-build-lxc: add --keyring option for consistency with qemu
  * setup-testbed: check the testbed for init-availability
  * setup-testbed: reliably deny starting services

  [ Tim Andersson ]
  * Fix docker build command not returning 1 on failure, causing test to fail
    and not be marked as skippable when run behind a proxy
  * Add timestamps to logfile

 -- Antonio Terceiro <terceiro@debian.org>  Wed, 14 Jun 2023 20:23:45 -0300

autopkgtest (5.28) unstable; urgency=medium

  [ Jochen Sprickerhof ]
  * virt-unshare: use rbind to mount subtrees

  [ Christian Kastner ]
  * QEMU: Enable virtio-serial exactly once (Closes: #1003002)

  [ Paride Legovini ]
  * Pin pockets with Pin-Priority: 500

  [ Paul Gevers ]
  * virt/podmon: don't fail on stderr while stopping container

  [ Ryan Tandy ]
  * Fix qemu failing to boot raw base image (Closes: #1004226)

  [ Jelmer Vernooij ]
  * Print nicer error message when cleaning up schroot times out.

 -- Paul Gevers <elbrus@debian.org>  Mon, 30 Jan 2023 19:29:59 +0100

autopkgtest (5.27) unstable; urgency=medium

  [ Julian Gilbey ]
  * Add timezone to initial informative line

  [ Johannes Schauer Marin Rodrigues ]
  * setup-commands/setup-testbed: support running in d-i

  [ Simon McVittie ]
  * setup-testbed: Remove /usr/sbin/policy-rc.d when setting up init
  * setup-testbed: Install procps along with sysv-rc or openrc

  [ Emanuele Rocca ]
  * qemu-system-aarch64: use read-only=on
  * Add zerofree to Suggests, needed by autopkgtest-build-qemu

  [ Paul Gevers ]
  * Improve Architecture field documentation
  * Retry lxc-copy and lxc-start if they fail
  * adt_testbed: fix logical error

 -- Paul Gevers <elbrus@debian.org>  Wed, 26 Oct 2022 22:11:34 +0200

autopkgtest (5.26) unstable; urgency=medium

  [ Simon McVittie ]
  * Add a needs-sudo restriction.
    This can be used by packages like gvfs to run tests that need to be run
    as an ordinary user, but also require the ability to elevate privileges
    to do setup and/or teardown steps. (Closes: #906424)
  * Fix a long-standing race condition in test stdout/stderr reporting,
    which particularly affects the unshare backend (Closes: #1017974)
  * await-boot: Fix a regression in 5.25 which affected tests that
    reboot into a sysvinit environment, such as munin
  * Start factoring out shell code that runs in the testbed into scripts
    lib/in-testbed/*.sh, so that we can include comments, run lint checks
    and other useful QA things
  * testbed: Make reboot-request detection clearer by not relying on
    compensating errors
  * testbed, runner: Remove leftover bits of support for install-tmp mode,
    which was removed in 5.12
  * d/README.source: Document how to run snap lxd via sudo
  * doc: Sort restrictions and capabilities in alphabetical order
  * runner: Fix a pycodestyle warning
  * d/tests/lxd: Update to work with the version in Debian unstable
    - Add more test-dependencies
    - Modernize use of `lxd init`
    - Run as a user in the appropriate group
    - Use Debian testing instead of EOL Ubuntu 16.04 (Closes: #1016912)
  * d/tests/schroot: Ensure hostname resolves promptly
  * tests: Improve debug output for tests that reboot
  * tests: Avoid polluting stderr with diagnostic output
  * tests: Treat AUTOPKGTEST_TEST_INSTALLED= as uninstalled
  * tests: Make a test cope with custom arguments to virt backend
  * tests: Don't assert that there is no debug output from virt backend
  * tests: Get more debug info from SchrootRunner.test_foreign_arch_deps
  * tests: Get more debug info from DebTestsVirtContainer.test_timeout
  * tests: Get extra debug information from test_copy_timeout
  * tests: Skip test_timeout on lxd backend.
    This currently fails, which seems to be reliable, lxd-specific, and
    not a recent regression in autopkgtest. (Mitigates: #1020634)

  [ Paul Gevers ]
  * testbed: Fix creation of apt preferences for suites with a dot in
    the name

  [ Paride Legovini ]
  * qemu: Detect ppc64le host as able to run ppc64le qemu with KVM
    enabled (Closes: #1019189, LP: #1988527)

 -- Simon McVittie <smcv@debian.org>  Sun, 25 Sep 2022 10:35:21 +0100

autopkgtest (5.25) unstable; urgency=medium

  [ Antonio Terceiro ]
  * tests/autopkgtest: Fix test failure if the user has per-user
    containers in ~/.local/share for both lxc and the podman ecosystem

  [ Simon McVittie ]
  * Improve reliability of waiting for lxc, lxd, podman containers to
    boot an init system (Closes: #1017753)
  * On non-amd64 architectures, skip a test that assumes i386 can be a
    foreign architecture
  * Clarify documentation for Restrictions:
    - isolation-container implies a service manager (init system) such as
      systemd or sysv-rc
    - isolation-container does not guarantee logind
    - isolation-machine provides the same things as isolation-container
    - needs-root is at least root in a container, but not always global root
    Thanks: Paride Legovini

 -- Simon McVittie <smcv@debian.org>  Wed, 24 Aug 2022 09:49:01 +0100

autopkgtest (5.24) unstable; urgency=medium

  [ Jochen Sprickerhof ]
  * Install unshare-helper, fixing virt-unshare regression in 5.23

  [ Antonio Terceiro ]
  * virt-lxc: fix handling of --sudo when waiting for testbed to boot
    (Closes: #1017017)

  [ David Kalnischkies ]
  * virt-unshare: Create mount point for --bind if necessary

  [ Simon McVittie ]
  * testdesc: Represent restrictions and features as sets
  * testdesc: Check restrictions vs. capabilities in a data-driven way
  * build-docker(1): Fix an invalid groff macro (thanks, Lintian)
  * ssh-setup/maas: Silence a Lintian false positive
  * Test coverage for regressions in 5.23:
    - Test virt-unshare as an autopkgtest to exercise "as-installed" use
    - Test virt-lxc as an ordinary user, to detect regressions like #1017017
    - Test virt-unshare --bind
  * Test reliability:
    - Use testing in preference to unstable to avoid transient failures
      during transitions
  * Packaging updates:
    - Update syntax of Lintian overrides
    - Add myself to Uploaders
    - Standards-Version: 4.6.1 (no changes required)
    - d/tests: Correct SPDX license name

 -- Simon McVittie <smcv@debian.org>  Fri, 12 Aug 2022 09:39:40 +0100

autopkgtest (5.23) unstable; urgency=medium

  [ Iñaki Malerba, Chris Kuehl, Felipe Sateler, Simon McVittie ]
  * Add support for docker.io virtualization (Closes: #747909)

  [ Simon McVittie ]
  * virt-docker, build-docker: Allow running as virt-podman, build-podman
  * virt-podman, build-podman: Add --init option.
    Docker is designed to be used for "app containers", which are like a
    better-isolated chroot. Podman can be used like this, but can also be
    used to run traditional full-system containers in the same way as lxc
    and lxd, and in particular it has special support for running systemd
    as the container's init system.
    When we're running a service manager like systemd, sysv-rc or openrc,
    we can provide the isolation-container capability.
  * autopkgtest: Make --test-name repeatable (Closes: #1015921)
  * build-podman, build-qemu: Optionally swap or force the init system:
    systemd (+ logind), sysv-rc (+ elogind) or openrc (+ elogind).
    For qemu, the default is what debootstrap provides, usually systemd.
    For podman, the default is no init system at all.
  * Automatically create an unprivileged user to run tests if the testbed
    is expendable.
    This avoids needing to create an unprivileged user when building
    container and VM images, which build-lxc and build-podman don't do.
    (Closes: #1011202)
  * Load setup commands from the source tree if running uninstalled
  * Don't recurse or crash if auxverb_debug_fail fails
  * virt-lxc, virt-lxd: Factor out code to wait for container to boot.
    virt-lxc, virt-lxd and podman --init all want to do the same thing.
  * virt-unshare: Factor out unshare-helper into a shell script
  * Improve setup-testbed script:
    - Stop installing gpg.
      We've been installing this since 2018, but it seems we haven't needed
      it since we switched from apt-key to [trusted=yes] in 2015.
    - Only install dbus, rng-tools if we have an init system
    - Only install libpam-systemd if systemd is installed
    - Only set up ifupdown if it's installed
    - If we overwrite sources.list, also empty sources.list.d
    - Don't crash if unable to read /etc/apt/sources.list
    - Have a separate proxy setting for setup-testbed itself
    - Don't use /usr/share/doc to check package status
    - Silence a new shellcheck warning
  * Add a test that asserts tests can access pseudo-terminals
  * Run more tests on Gitlab-CI and from autopkgtest:
    - autopkgtest-virt-docker (can run via docker:dind or in qemu)
    - autopkgtest-virt-lxc (can run under privileged Docker or qemu)
    - autopkgtest-virt-podman (can run under privileged Docker or in qemu)
    - autopkgtest-virt-podman --init (can run in qemu)
    - autopkgtest-virt-schroot (can run under privileged Docker, lxc or qemu)
  * Test fixes, particularly for running tests that require privileges:
    - Fix ChrootRunner failure with glibc 2.34
    - Make dependencies more complete
    - Skip test_apt_autodep8_with_control if autodep8 not installed
    - Speed up test_git_source_build
    - Update for perl autodep8 behaviour changes in bullseye
    - Test the installed autopkgtest runner so autopkgtest doesn't break
      its own specification
    - Don't run lint-style tests as an autopkgtest, notably pyflakes
    - Accept more variations of apt output
    - Fix build of mock test package if a second binary is added
    - Cope with schroot not always having AUTOPKGTEST_NORMAL_USER
    - Make test failures easier to debug
    - Tolerate output before first explicit setup command
    - Cope with XDG basedirs environment variables being set
    - Speed up testing source package from apt by using a simpler package
      (src:tap.py rather than src:gdk-pixbuf)
    - Speed up testing schroot backend by repeating fewer tests
    - Speed up testing schroot backend by using /var/lib/schroot/unpack
      (schroot users should mount a fast filesystem in that location,
      ideally a tmpfs if they have enough RAM available)
    - Speed up testing schroot backend by using an uncompressed tarball
    - Ignore absence of /dev/pts while testing the virt-chroot backend
    - Make Podman containers available in mock home directory
    - Never completely clear the environment
    - Make the test apt archive readable by everyone, fixing failures with
      some virtualization backends
    - Install libpam-elogind instead of libpam-systemd in VMs and system
      containers that boot with a non-systemd init
  * Documentation:
    - d/README.source: Refer to latest Debian stable and Ubuntu LTS
    - d/README.source: Don't recommend manual setup for lxc networking,
      no longer needed
    - d/README.source: Describe how to run unit tests
    - Fix name of build-needed restriction in man page
  * Clean up dead code:
    - Remove support for click and Ubuntu Mobile.
      These technologies are no longer maintained, and none of the
      autopkgtest maintainers test autopkgtest's support for them, so
      it's very likely that this doesn't actually work anyway.
      (Closes: #1011207)
    - Remove internal support for obsolete actions from the pre-2017
      adt-run CLI

  [ Jochen Sprickerhof ]
  * virt-unshare: add /dev/{stdin,stdout,stderr}
  * virt-unshare: support bind mounts
  * virt-unshare: reduce redundancy

  [ Paride Legovini ]
  * virt-lxd: Add support for LXD VMs
  * buildvm-ubuntu-cloud: fix Xenial disk image name

  [ Guilhem Moulin ]
  * Fix "UnboundLocalError: local variable 'n' referenced before assignment"
    (Closes: #1010338)

  [ Johannes Schauer Marin Rodrigues ]
  * virt-unshare: Mount a new instance of /dev/pts, fixing ability to
    use script(1) and other users of pseudo-terminals

 -- Simon McVittie <smcv@debian.org>  Wed, 10 Aug 2022 20:50:12 +0100

autopkgtest (5.22) unstable; urgency=medium

  [ Luca Boccassi ]
  * Add --skip-test command line option

  [ Jochen Sprickerhof ]
  * Add unshare backend

  [ Simon McVittie ]
  * Avoid more uses of which(1)
  * buildvm-ubuntu-cloud: Don't rely on a global variable
  * buildvm-ubuntu-cloud: Trim unused space from the image if possible
  * buildvm-ubuntu-cloud: Optionally compress the final image

  [ Jochen Sprickerhof ]
  * [unshare] support suggested-normal-user

  [ Paul Gevers ]
  * Support current oldstable/updates which is need for security

 -- Paul Gevers <elbrus@debian.org>  Sat, 14 May 2022 12:55:32 +0200

autopkgtest (5.21) unstable; urgency=medium

  [ Paul Gevers ]
  * testdesc.py: reduce_restrictions instead of only reduce_arch
    (Closes: #1008192)
  * spec: improve wording of skip-not-installable
  * testdesc: work around variables in d/control
  * spec: be more specific what @recommends@ means

  [ Antonio Terceiro ]
  * autopkgtest-build-lxc: update container configuration (Closes: #979450)

 -- Paul Gevers <elbrus@debian.org>  Mon, 28 Mar 2022 21:20:12 +0200

autopkgtest (5.20) unstable; urgency=medium

  * Determine build-needed by parsing the control (Closes: #1002477)
  * Implement support for @recommends@ in test dependencies (Closes: #896698)
  * Update documentation
  * Convert `needs-recommends` to @recommends@ and drop all other code
    related to it

 -- Paul Gevers <elbrus@debian.org>  Thu, 24 Feb 2022 20:29:51 +0100

autopkgtest (5.19) unstable; urgency=medium

  [ Simon Chopin ]
  * buildvm-ubuntu-cloud: add a --ram-size option
  * buildvm-ubuntu-cloud: add support for non-x86 architectures

  [ Paul Gevers ]
  * autopkgtest-virt-lxc: cleanup if lxc-start fails after lxc-copy

  [ Athos Ribeiro ]
  * Force xz compression for satdep.deb

  [ Sergio Durigan Junior ]
  * Make sure we add a newline to the end of /etc/environment

 -- Antonio Terceiro <terceiro@debian.org>  Tue, 07 Dec 2021 09:28:26 -0300

autopkgtest (5.18) unstable; urgency=medium

  [ Romain Porte ]
  * Fix qemu deprecation warnings for short-form booleans (Closes: #996705)

  [ Brian Murray ]
  * Add support for building VMs of End of Life ubuntu releases.

 -- Antonio Terceiro <terceiro@debian.org>  Sat, 13 Nov 2021 11:44:27 -0300

autopkgtest (5.17) unstable; urgency=medium

  [ Ryutaroh Matsumoto ]
  * Use 32-bit OVMF EFI firmware for qemu-system-i386 (Closes: #973522)
  * qemu: Explicitly assign unit numbers for pflash devices

  [ Iain Lane ]
  * lxd: Fix a race condition while rebooting
  * buildvm-ubuntu-cloud: Update for compatibility with other changes
    mentioned below
  * ssh-setup/nova: Quote arguments to `tr`

  [ Simon McVittie ]
  * VirtSubproc: Allow expecting multiple options
  * virt-qemu: Cope with passwordless shell (blank password)
  * virt-qemu: Don't rely on exiting from a shell printing "logout"
  * virt-qemu: Preseed debconf questions so we can upgrade grub-pc, if
    installed (Closes: #982296)
  * virt-qemu: Add --qemu-architecture, --dpkg-architecture options
  * virt-qemu: Load virtio_console in initramfs to make sure it's ready
    when systemd-getty-generator(8) looks for it (workaround for #689962)
  * virt-qemu: Improve reliability of interactions with serial console shell
  * build-qemu: Automatically run under fakemachine if not uid 0
  * build-qemu: Convert image into an absolute path.
    This helps when we're sharing directories as "volumes" with fakemachine.
    The working directory inside fakemachine isn't necessarily the same as
    the working directory outside, leading to the output image being
    written somewhere unintended.
  * build-qemu: Show the log from vmdb2 if it fails
  * build-qemu: Placate pycodestyle
  * build-qemu: Never set http_proxy to DIRECT.
    The special keyword DIRECT is understood by apt, but not by generic
    http clients, and in particular not understood by wget (used by
    debootstrap).
  * Use `command -v` in preference to `which`.
    In Debian, which(1) is provided by the Essential debianutils package,
    which recently deprecated it. Silence the resulting warnings by doing
    this in a slightly less obvious way.

  [ Simon McVittie, Ryutaroh Matsumoto ]
  * setup-testbed: Try to put Linux console on both ttyS0 and hvc0.
    ttyS0 is PC-specific, hvc0 is a generic hypervisor console available
    on multiple hypervisors.
  * setup-testbed: Put root shells on both ttyS1 and hvc1 if they exist.
    ttyS1 is PC-specific, hvc1 is a generic hypervisor console available
    on multiple hypervisors.
  * virt-qemu: Only -enable-kvm if VM is compatible with host architecture
  * virt-qemu: Add --boot=efi (formerly --efi)
  * build-qemu: Add --boot=efi to build images bootable with EFI.
    This requires vmdb2 0.22-1~ or newer.
  * qemu: armhf and aarch64 support (Closes: #973038, #973663)
    - Boot with EFI by default
    - Build images with EFI by default (Closes: #990415)
    - Use ttyAMA0 as the ARM equivalent of ttyS0
    - Default to -machine virt, since there is no default in qemu
    - Default to qemu-system-aarch64 -cpu host,aarch64=off -enable-kvm
      for armhf on aarch64 host, because qemu-system-arm -enable-kvm is
      not available on aarch64 hosts
    - Default to -cpu host -enable-kvm for aarch64 on aarch64 host
    - Default to -cpu cortex-a53 for aarch64 on non-aarch64 host
      since that CPU seems to work well
    Thanks to Christian Kastner, Peter Maydell and Steve McIntyre.

  [ Simon McVittie, Thierry Fauck, Ryutaroh Matsumoto ]
  * qemu: ppc64el support (Closes: #926945)
    - Install grub-ieee1275 by default
    - Avoid trying to allocate hvc0 as a virtio console.
      The default serial port of a pSeries machine appears as /dev/hvc0,
      and the virtio consoles start from hvc1.
    Thanks to Christian Kastner

  [ Christian Kastner ]
  * qemu: Use -machine q35 on i386 or amd64 when booting with EFI.
    Empirically, it seems to be the minimum required for EFI-booting on
    i386; bump the machine on amd64 too, for consistency.

  [ Julian Andres Klode ]
  * setup-testbed: Remove needrestart so its dpkg hook does not interfere
    with the apt test suite
  * setup-testbed: Set Acquire::Retries 10, like debci does
  * setup-testbed: Always include phased updates

 -- Paul Gevers <elbrus@debian.org>  Mon, 04 Oct 2021 21:04:48 +0200

autopkgtest (5.16) unstable; urgency=medium

  [ Paul Gevers ]
  * Fix reported arch in Unsupported message

  [ Simon McVittie ]
  * tests/ssh-setup-lxd: Fix a typo
  * shell scripts: Quote more defensively
  * tests/pycodestyle: Prefer command -v instead of which
  * shell scripts: Prefer $() instead of backticks
  * setup-testbed: Avoid test -a
  * setup-testbed: Silence some shellcheck false-positives
  * setup-testbed: Be more careful with printf
  * setup-testbed: Ensure that $proxy is always initialized
  * setup-testbed: Prefer POSIX grep -E over GNU-specific egrep
  * setup-testbed: Quote trap command differently
  * tests: Add shellcheck test
  * tests: Silence some mypy warnings
  * tests: Add test that runs mypy across the codebase
  * d/copyright: Update
  * Use shlex.quote in preference to undocumented pipes.quote

  [ Ryutaroh Matsumoto ]
  * autopkgtest-build-qemu: Install a PAE kernel on i386 (Closes: #973662)
  * autopkgtest-build-qemu: Install LPAE kernel on armhf (Closes: #973592)

  [ Simon McVittie ]
  * lib: Factor out qemu virtual machine setup
  * autopkgtest_qemu: Add QemuImage objects
  * buildvm-ubuntu-cloud: Use Qemu object
  * autopkgtest-build-qemu: Rewrite in Python
  * autopkgtest-buildvm-ubuntu-cloud: Make return of None explicit
  * autopkgtest-buildvm-ubuntu-cloud: Fail if release cannot be determined
  * autopkgtest-buildvm-ubuntu-cloud: Replace which(1) with shutil.which
  * autopkgtest_qemu: Set workdir before preparing overlay

  [ Ryutaroh Matsumoto ]
  * qemu: Forward stdout, stderr to stderr of parent process
  * qemu: Extend timeout for checking python availability
  * qemu: Enable discard operation on virtio disk devices

  [ Simon McVittie ]
  * qemu: Allow passing `uname -m` output to get_default_qemu_command
  * tests: Add a unit test for qemu library code
  * qemu: Select qemu-system-arm for ARM CPUs

  [ Graham Inggs ]
  * autpkgtest_args: autoremove after dist-upgrade

  [ Balint Reczey ]
  * Handle exception thrown by create_testinfo() (Closes: #927146)
    (LP: #1907803)

  [ Sébastien Delafond ]
  * virt-lxc: attempt to cleanly shutdown the container first, and only
    then pass --force to lxc-destroy (Closes: #979238)

 -- Paul Gevers <elbrus@debian.org>  Sun, 24 Jan 2021 21:15:20 +0100

autopkgtest (5.15) unstable; urgency=medium

  [ Sebastien Delafond ]
  * Remove left over .new containers before trying to generate a new one
    (Closes: #971749)

  [ Antonio Terceiro ]
  * virt-lxc: extract common initial argument list for lxc-copy
  * virt-lxc: add option to limit disk usage by tests

  [ Paul Gevers ]
  * tests/lxd: mark test skippable and exit 77 in stead of 0 in case of
    balling-out
  * Add support for Architecture field (Closes: #970513)
  * Check for empty Tests field (Closes: #918882)
  * With --test-name, don't report when other tests are skipped
    (Closes: #960267)

  [ Simon McVittie ]
  * Check restrictions with testbed compat, not during initialization
  * Allow restrictions to be ignored from the command line

  [ Ivo De Decker ]
  * Assume root-on-testbed with autopkgtest-virt-ssh and improve debugging
    (Closes: #958727)

 -- Paul Gevers <elbrus@debian.org>  Mon, 26 Oct 2020 21:27:25 +0100

autopkgtest (5.14) unstable; urgency=medium

  [ Christian Kastner ]
  * autopkgtest-build-qemu: Support for vmdb2->qemu-debootstrap
    (Closes: #959389)

  [ Antonio Terceiro ]
  * autopkgtest-build-qemu: make sure VM can resolve its own hostname
    (Closes: #959713)
  * autopkgtest: add --validate option

  [ Iain Lane ]
  * autopkgtest-virt-ssh: Give the wait_port_down socket a timeout

  [ Simon McVittie ]
  * Avoid using 'l' as a variable name
  * qemu: Guess format of main disk image (Closes: #968598)
  * tools: Don't make qemu guess what format the disk image is

  [ Paul Gevers ]
  * Bump standards
  * Bump debhelper compat to 13 via debhelper-compat BD
  * Add Rules-Requires-Root: no
  * Drop postinst script as all supported releases have higher versions

 -- Paul Gevers <elbrus@debian.org>  Tue, 01 Sep 2020 21:28:29 +0200

autopkgtest (5.13.1) unstable; urgency=medium

  * autopkgtest-build-qemu: revert commit that broke image creation
    (Closes: #956659)

 -- Antonio Terceiro <terceiro@debian.org>  Fri, 17 Apr 2020 22:02:07 -0300

autopkgtest (5.13) unstable; urgency=medium

  [ Gordon Ball ]
  * Use pyflakes3 instead of pyflakes (Closes: #956338)

  [ Paul Gevers ]
  * Add support for needs-internet restriction
  * Add note about ftp-master ruling (Closes: #954157)
  * README.package-tests.rst: add documentation about needs-internet
    restriction
  * Update 5.12 changelog entry with bug number for qemu on ppc64el item

 -- Paul Gevers <elbrus@debian.org>  Thu, 16 Apr 2020 21:07:58 +0200

autopkgtest (5.12.1) unstable; urgency=medium

  [ Antonio Terceiro ]
  * adt_testbed: ignore debian/control when checking for dependencies. This
    fixes a regression observed in the debci test suite.

 -- Antonio Terceiro <terceiro@debian.org>  Sat, 04 Apr 2020 12:20:17 -0300

autopkgtest (5.12) unstable; urgency=medium

  [ Dan Streetman ]
  * tools/autopkgtest-build-lxd: pass /dev/null on stdin to lxc launch
    (LP: #1845037)
  * autopkgtest: When finding src pkg, skip binary pkgs for other archs
    (LP: #1845157) (Closes: #939790)
  * autopkgtest: when checking binary pkg arch, allow *-$ARCH-* values also

  [ Antonio Terceiro ]
  * Drop unpacking of dependencies to temporary dir

  [ Iain Lane ]
  * setup-testbed: Install rng-tools
  * lib/adt_testbed.py, runner/autopkgtest: Run --shell-fail in more situations
  * adt_testbed: Run the debug-fail command in more circumstances

  [ Sébastien Delafond ]
  * Add kali support

  [ Simon McVittie ]
  * lxd: Actually exit the awk loop after the first apt source
  * build-lxd: Quote MIRROR and RELEASE properly
  * d/README.source: Document how to test various backends

  [ Paul Gevers ]
  * adt_testbed.py: add date to the start of log so we always have it
    (Closes: #954366)
  * Do not ignore distributions that have dashes in their name
  * lxc/lxd: wait for sysvinit services to finish
    Thanks to Lars Kruse (Closes: #953655)
  * lxc: increase timeout around reboot
  * tests/lxd: add skip-not-installable (Closes: #952594)

  [ Jelmer Vernooĳ ]
  * Document that $HOME will exist and will be writeable.

  [ Thierry Fauck ]
  * autopkgtest-build-qemu: create primary partition of type Prep to
    support ppc64el with grub2 (Closes: #926945)
  * Add proper kernel release name for ppc64el

 -- Paul Gevers <elbrus@debian.org>  Thu, 02 Apr 2020 10:36:09 +0200

autopkgtest (5.11) unstable; urgency=medium

  [ Dan Streetman ]
  * autopkgtest-buildvm-ubuntu-cloud: work with precise and trusty
    (LP: #1822331) (Closes: #925966)

  [ Sébastien Delafond ]
  * Add an optional 6th parameter to autopkgtest-build-qemu, to force a
    specific image size

  [ Julian Andres Klode ]
  * ssh-setup/nova: Run nova show after console-log in debug_failure

  [ Iain Lane ]
  * setup-testbed: Add the -security pocket for Ubuntu releases
  * nova: Use glanceclient to find images
  * nova: --key_name is actually --key-name
  * setup-testbed: Write preserve_sources_list in the new format
  * nova: trim whitespace from server UUID

  [ Simon McVittie ]
  * autopkgtest-build-qemu: Parse named parameters
  * autopkgtest-build-qemu: Allow overriding apt proxy via command-line

  [ Simon McVittie ]
  * testdesc: Report each unsupported test individually (Closes: #851232)
  * setup-testbed: Provide more options for handling /etc/apt/sources.list
    (Closes: #933062)

  [ Dan Streetman ]
  * ssh-setup/nova: allow specifying --image with name or uuid

  [ Valentin Vidic ]
  * autopkgtest-virt-lxc: accept lxc arguments for ephemeral containers

  [ Michael Biebl ]
  * Use virtio-rng to passthrough RNG to qemu runner and drop haveged

  [ Raphaël Hertzog ]
  * qemu: Forward VM's ssh port only to localhost (Closes: #931219)

 -- Paul Gevers <elbrus@debian.org>  Thu, 05 Sep 2019 09:32:10 +0200

# Older entries have been removed from this changelog.
# To read the complete changelog use `apt changelog autopkgtest`.
